/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.gebietsbaum.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.gebietsbaum.entity.GebietUK;

public abstract class AbstractGebietDAO extends de.ivu.elect.jee.entity.AbstractDAO<Gebiet,
        de.ivu.elect.business.gebietsbaum.entity.GebietPK
    , GebietUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractGebietDAO.class);

  public AbstractGebietDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.gebietsbaum.entity.GebietPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Gebiet findByPrimaryKey(
        de.ivu.elect.business.gebietsbaum.entity.GebietPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Gebiet findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Gebiet.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: CountByWahlMitVerantwortlicherMandantNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM Gebiet o WHERE o.wahl=?1 AND o.verantwortlicherMandant IS NOT NULL<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountByWahlMitVerantwortlicherMandant( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GEBIET.CountByWahlMitVerantwortlicherMandant")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountByWahlMitVerantwortlicherMandant - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByCountByWahlMitVerantwortlicherMandant - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountByWahlMitVerantwortlicherMandant(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountErfassungsgebieteByWahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT count(g) FROM Gebiet g WHERE g.wahl=?1 AND EXISTS (SELECT gae FROM Gebietsarteigenschaft gae WHERE gae.gebietsart=g.gebietsart AND gae.wahlart=(SELECT w.wahlart FROM Wahl w WHERE w=?1) AND gae.erfassungsgebiet=1)<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountErfassungsgebieteByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GEBIET.CountErfassungsgebieteByWahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountErfassungsgebieteByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByCountErfassungsgebieteByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountErfassungsgebieteByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountGebieteByGebietsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT count(o) FROM Gebiet o WHERE o.gebietsart=?1<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountGebieteByGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.gebietsbaum.entity.Gebietsart.class, "gebietsart"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GEBIET.CountGebieteByGebietsart")
                              .setParameter(1, gebietsartCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByCountGebieteByGebietsart - NonUniqueResultException, Parameter: "
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountGebieteByGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountGebieteByWahlAndGebietsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT count(o) FROM Gebiet o WHERE o.wahl=?1 AND o.gebietsart=?2<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountGebieteByWahlAndGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.gebietsbaum.entity.Gebietsart.class, "gebietsart"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GEBIET.CountGebieteByWahlAndGebietsart")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, gebietsartCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountGebieteByWahlAndGebietsart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByCountGebieteByWahlAndGebietsart - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountGebieteByWahlAndGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountGebieteByWahlAndGebietsartenNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT count(o) FROM Gebiet o WHERE o.wahl=?1 AND o.gebietsart IN ?2<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountGebieteByWahlAndGebietsarten( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebietsart> gebietsarten) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebietsart> gebietsartenCheckedAndAttached =  gebietsarten ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GEBIET.CountGebieteByWahlAndGebietsarten")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, gebietsartenCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountGebieteByWahlAndGebietsarten - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByCountGebieteByWahlAndGebietsarten - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", gebietsarten:'"+gebietsarten+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountGebieteByWahlAndGebietsarten(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountUntergeordneteGebieteNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM Gebiet o WHERE o.uebergeordnetesGebiet = ?1<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountUntergeordneteGebiete( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GEBIET.CountUntergeordneteGebiete")
                              .setParameter(1, gebietCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountUntergeordneteGebiete - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByCountUntergeordneteGebiete - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountUntergeordneteGebiete(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountWahlartGebietsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM Gebiet o WHERE o.wahl.wahlart=?1 AND o.gebietsart =?2<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountWahlartGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahlart wahlart,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahlart wahlartCheckedAndAttached =  checkAndAttach(wahlart, de.ivu.elect.business.wahl.entity.Wahlart.class, "wahlart"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.gebietsbaum.entity.Gebietsart.class, "gebietsart"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GEBIET.CountWahlartGebietsart")
                              .setParameter(1, wahlartCheckedAndAttached)
                                        .setParameter(2, gebietsartCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByCountWahlartGebietsart - NonUniqueResultException, Parameter: "
           + ", wahlart:'"+wahlart+"'"
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountWahlartGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: UebergeordnetesGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.uebergeordnetesGebiet = ?1<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByUebergeordnetesGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet uebergeordnetesGebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet uebergeordnetesGebietCheckedAndAttached =  checkAndAttach(uebergeordnetesGebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "uebergeordnetesGebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.UebergeordnetesGebiet")
                              .setParameter(1, uebergeordnetesGebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByUebergeordnetesGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByUebergeordnetesGebiet - NonUniqueResultException, Parameter: "
           + ", uebergeordnetesGebiet:'"+uebergeordnetesGebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByUebergeordnetesGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndDirektwahlgebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT g FROM Gebiet g, Gebietsarteigenschaft e WHERE g.wahl = ?1 AND g.gebietsart = e.gebietsart AND e.direktwahlgebiet = ?2 AND g.wahl.wahlart = e.wahlart ORDER BY g.position<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlAndDirektwahlgebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.lang.Boolean isDirektwahlgebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.lang.Boolean isDirektwahlgebietCheckedAndAttached =  isDirektwahlgebiet ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndDirektwahlgebiet")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, isDirektwahlgebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndDirektwahlgebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndDirektwahlgebiet - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", isDirektwahlgebiet:'"+isDirektwahlgebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndDirektwahlgebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndGebietsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from Gebiet o where o.wahl=?1 and o.gebietsart=?2<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlAndGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.gebietsbaum.entity.Gebietsart.class, "gebietsart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndGebietsart")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, gebietsartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndGebietsart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndGebietsart - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndListengebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT g FROM Gebiet g, Gebietsarteigenschaft e WHERE g.wahl = ?1 AND g.gebietsart = e.gebietsart AND e.listenwahlgebiet = ?2 AND g.wahl.wahlart = e.wahlart ORDER BY g.position<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlAndListengebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.lang.Boolean isListengebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.lang.Boolean isListengebietCheckedAndAttached =  isListengebiet ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndListengebiet")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, isListengebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndListengebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndListengebiet - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", isListengebiet:'"+isListengebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndListengebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndNameAutoCompleteNoFlush<br>
      * Beschreibung: Wird für das Autocomplete verwendet (in der Schnellsuche).<br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl =?1 AND UPPER(o.name) LIKE UPPER(?2) ORDER BY o.name<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlAndNameAutoComplete( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String name) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String nameCheckedAndAttached =  checkAndAttach(name, String.class, "name"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndNameAutoComplete")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, nameCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndNameAutoComplete - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndNameAutoComplete - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", name:'"+name+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndNameAutoComplete(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndNummerAndGebietsartNameNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl =?1 AND o.nummer=?2 and o.gebietsart.name=?3<br>
      * SQL: <br>
      */
     public Gebiet findByWahlAndNummerAndGebietsartName( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String nummer,  @javax.annotation.Nonnull String gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String nummerCheckedAndAttached =  checkAndAttach(nummer, String.class, "nummer"); ;
		  			  String gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, String.class, "gebietsart"); ;
		  
                              return
                    (Gebiet)
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndNummerAndGebietsartName")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, nummerCheckedAndAttached)
                                        .setParameter(3, gebietsartCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndNummerAndGebietsartName - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndNummerAndGebietsartName - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", nummer:'"+nummer+"'"
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndNummerAndGebietsartName(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndNummerAndGebietsartNameOptionalNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl =?1 AND o.nummer=?2 and o.gebietsart.name=?3<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlAndNummerAndGebietsartNameOptional( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String nummer,  @javax.annotation.Nonnull String gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String nummerCheckedAndAttached =  checkAndAttach(nummer, String.class, "nummer"); ;
		  			  String gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, String.class, "gebietsart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndNummerAndGebietsartNameOptional")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, nummerCheckedAndAttached)
                                        .setParameter(3, gebietsartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndNummerAndGebietsartNameOptional - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndNummerAndGebietsartNameOptional - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", nummer:'"+nummer+"'"
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndNummerAndGebietsartNameOptional(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndNummerAndGebietsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl =?1 AND o.nummer=?2 and o.gebietsart=?3<br>
      * SQL: <br>
      */
     public Gebiet findByWahlAndNummerAndGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String nummer,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String nummerCheckedAndAttached =  checkAndAttach(nummer, String.class, "nummer"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.gebietsbaum.entity.Gebietsart.class, "gebietsart"); ;
		  
                              return
                    (Gebiet)
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndNummerAndGebietsart")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, nummerCheckedAndAttached)
                                        .setParameter(3, gebietsartCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndNummerAndGebietsart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndNummerAndGebietsart - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", nummer:'"+nummer+"'"
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndNummerAndGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndNummerAndGebietsartenAutoCompleteNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl =?1 AND o.nummer LIKE ?2 AND o.gebietsart IN (?3) ORDER BY o.nummer<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlAndNummerAndGebietsartenAutoComplete( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.lang.String nummer,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebietsart> gebietsarten) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.lang.String nummerCheckedAndAttached =  nummer ;
		  			  java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebietsart> gebietsartenCheckedAndAttached =  gebietsarten ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndNummerAndGebietsartenAutoComplete")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, nummerCheckedAndAttached)
                                        .setParameter(3, gebietsartenCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndNummerAndGebietsartenAutoComplete - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndNummerAndGebietsartenAutoComplete - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", nummer:'"+nummer+"'"
           + ", gebietsarten:'"+gebietsarten+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndNummerAndGebietsartenAutoComplete(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndNummerAutoCompleteNoFlush<br>
      * Beschreibung: Wird für das Autocomplete verwendet (in der Schnellsuche).<br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl =?1 AND o.nummer LIKE ?2 ORDER BY o.nummer<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlAndNummerAutoComplete( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String nummer) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String nummerCheckedAndAttached =  checkAndAttach(nummer, String.class, "nummer"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndNummerAutoComplete")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, nummerCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndNummerAutoComplete - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndNummerAutoComplete - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", nummer:'"+nummer+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndNummerAutoComplete(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndNummerNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl =?1 AND o.nummer=?2<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlAndNummer( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull String nummer) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  String nummerCheckedAndAttached =  checkAndAttach(nummer, String.class, "nummer"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndNummer")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, nummerCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndNummer - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndNummer - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", nummer:'"+nummer+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndNummer(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndUebergeordnetemGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT g FROM Gebiet g WHERE g.wahl = ?1 AND g.uebergeordnetesGebiet = ?2<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlAndUebergeordnetemGebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet uebergeordnetesGebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet uebergeordnetesGebietCheckedAndAttached =  checkAndAttach(uebergeordnetesGebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "uebergeordnetesGebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndUebergeordnetemGebiet")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, uebergeordnetesGebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndUebergeordnetemGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndUebergeordnetemGebiet - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", uebergeordnetesGebiet:'"+uebergeordnetesGebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndUebergeordnetemGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlAndWahlgebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT g FROM Gebiet g, Gebietsarteigenschaft e WHERE g.wahl = ?1 AND g.gebietsart = e.gebietsart AND e.wahlgebiet = ?2 AND g.wahl.wahlart = e.wahlart ORDER BY g.position<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlAndWahlgebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.lang.Boolean isWahlgebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  java.lang.Boolean isWahlgebietCheckedAndAttached =  isWahlgebiet ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlAndWahlgebiet")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, isWahlgebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlAndWahlgebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlAndWahlgebiet - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", isWahlgebiet:'"+isWahlgebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndWahlgebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlDeleteNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE FROM Gebiet g WHERE g.wahl=?1<br>
      * SQL: <br>
      */
     public Integer deleteWahlDelete( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlDelete")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("deleteWahlDelete - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, deleteWahlDelete - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteWahlDelete(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlMitVerantwortlicherMandantNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl=?1 AND o.verantwortlicherMandant IS NOT NULL<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlMitVerantwortlicherMandant( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlMitVerantwortlicherMandant")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlMitVerantwortlicherMandant - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlMitVerantwortlicherMandant - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlMitVerantwortlicherMandant(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl =?1<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlOrderByPositionNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl =?1 ORDER BY o.position<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlOrderByPosition( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlOrderByPosition")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlOrderByPosition - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlOrderByPosition - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlOrderByPosition(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlVerantwortlicherMandantNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahl=?1 AND o.verantwortlicherMandant = ?2<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlVerantwortlicherMandant( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant verantwortlicherMandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.mandant.entity.Mandant verantwortlicherMandantCheckedAndAttached =  checkAndAttach(verantwortlicherMandant, de.ivu.elect.business.mandant.entity.Mandant.class, "verantwortlicherMandant"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlVerantwortlicherMandant")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, verantwortlicherMandantCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlVerantwortlicherMandant - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlVerantwortlicherMandant - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", verantwortlicherMandant:'"+verantwortlicherMandant+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlVerantwortlicherMandant(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlWurzelgebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT g FROM Gebiet g WHERE g.wahl = ?1 AND g.uebergeordnetesGebiet IS NULL<br>
      * SQL: <br>
      */
     public Gebiet findByWahlWurzelgebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                    (Gebiet)
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlWurzelgebiet")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlWurzelgebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlWurzelgebiet - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlWurzelgebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminAndGebietsartNoFlush<br>
      * Beschreibung: Wird zur Bestimmung der Berechtigung auf Gebieten verwendet, siehe MucWos-Security.<br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahltermin =?1 AND o.gebietsart=?2<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlterminAndGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.gebietsbaum.entity.Gebietsart.class, "gebietsart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlterminAndGebietsart")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, gebietsartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminAndGebietsart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlterminAndGebietsart - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminAndGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminAndNameAutoCompleteNoFlush<br>
      * Beschreibung: Wird für das Autocomplete im WOS verwendet (in der Schnellsuche).<br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahltermin =?1 AND UPPER(o.name) LIKE UPPER(?2) ORDER BY o.name<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlterminAndNameAutoComplete( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull String name,  int limit) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  String nameCheckedAndAttached =  checkAndAttach(name, String.class, "name"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlterminAndNameAutoComplete")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, nameCheckedAndAttached)
                                                  .setMaxResults(limit)
                                        .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminAndNameAutoComplete - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlterminAndNameAutoComplete - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", name:'"+name+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminAndNameAutoComplete(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminAndNummerAndGebietsartNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahltermin =?1 AND o.nummer=?2 and o.gebietsart=?3<br>
      * SQL: <br>
      */
     public Gebiet findByWahlterminAndNummerAndGebietsart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull String nummer,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  String nummerCheckedAndAttached =  checkAndAttach(nummer, String.class, "nummer"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebietsart gebietsartCheckedAndAttached =  checkAndAttach(gebietsart, de.ivu.elect.business.gebietsbaum.entity.Gebietsart.class, "gebietsart"); ;
		  
                              return
                    (Gebiet)
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlterminAndNummerAndGebietsart")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, nummerCheckedAndAttached)
                                        .setParameter(3, gebietsartCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminAndNummerAndGebietsart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlterminAndNummerAndGebietsart - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", nummer:'"+nummer+"'"
           + ", gebietsart:'"+gebietsart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminAndNummerAndGebietsart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminAndNummerAutoCompleteNoFlush<br>
      * Beschreibung: Wird für das Autocomplete verwendet (in der Schnellsuche).<br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahltermin =?1 AND o.nummer LIKE ?2 ORDER BY o.nummer<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlterminAndNummerAutoComplete( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull String nummer,  int limit) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  String nummerCheckedAndAttached =  checkAndAttach(nummer, String.class, "nummer"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlterminAndNummerAutoComplete")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, nummerCheckedAndAttached)
                                                  .setMaxResults(limit)
                                        .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminAndNummerAutoComplete - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlterminAndNummerAutoComplete - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", nummer:'"+nummer+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminAndNummerAutoComplete(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminAndUebergeordnetemGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT g FROM Gebiet g WHERE g.wahltermin = ?1 AND g.uebergeordnetesGebiet = ?2<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlterminAndUebergeordnetemGebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet uebergeordnetesGebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet uebergeordnetesGebietCheckedAndAttached =  checkAndAttach(uebergeordnetesGebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "uebergeordnetesGebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlterminAndUebergeordnetemGebiet")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, uebergeordnetesGebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminAndUebergeordnetemGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlterminAndUebergeordnetemGebiet - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", uebergeordnetesGebiet:'"+uebergeordnetesGebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminAndUebergeordnetemGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminDeleteNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE FROM Gebiet g WHERE g.wahltermin=?1<br>
      * SQL: <br>
      */
     public Integer deleteWahlterminDelete( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlterminDelete")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("deleteWahlterminDelete - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, deleteWahlterminDelete - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteWahlterminDelete(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahltermin =?1<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahltermin( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.Wahltermin")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahltermin - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahltermin - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahltermin(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminVerantwortlicherMandantNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gebiet o WHERE o.wahltermin=?1 AND o.verantwortlicherMandant = ?2<br>
      * SQL: <br>
      */
     public java.util.List<Gebiet> findByWahlterminVerantwortlicherMandant( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant verantwortlicherMandant) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  de.ivu.elect.business.mandant.entity.Mandant verantwortlicherMandantCheckedAndAttached =  checkAndAttach(verantwortlicherMandant, de.ivu.elect.business.mandant.entity.Mandant.class, "verantwortlicherMandant"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlterminVerantwortlicherMandant")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, verantwortlicherMandantCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminVerantwortlicherMandant - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlterminVerantwortlicherMandant - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", verantwortlicherMandant:'"+verantwortlicherMandant+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminVerantwortlicherMandant(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminWurzelgebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT g FROM Gebiet g WHERE g.wahltermin = ?1 AND g.uebergeordnetesGebiet IS NULL<br>
      * SQL: <br>
      */
     public Gebiet findByWahlterminWurzelgebiet( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                    (Gebiet)
                              getEntityManager().
                                createNamedQuery("GEBIET.WahlterminWurzelgebiet")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminWurzelgebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gebiet, findByWahlterminWurzelgebiet - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminWurzelgebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.gebietsbaum.entity.GebietUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.gebietsbaum.entity.GebietUK uk,
        de.ivu.elect.business.gebietsbaum.entity.GebietPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.gebietsbaum.entity.Gebiet findByUK(de.ivu.elect.business.gebietsbaum.entity.GebietUK uk){

    try {
     return (de.ivu.elect.business.gebietsbaum.entity.Gebiet) getEntityManager().createNamedQuery("GEBIET.UK")
                  .setParameter(1, uk
                .getNummer ()  
              )
             .setParameter(2, uk
                .getGebietsartUK ()  
                .getName ()  
              )
             .setParameter(3, uk
                .getGebietsartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(4, uk
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(5, uk
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(6, uk
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(7, uk
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(8, uk
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(9, uk
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(10, uk
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(11, uk
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Gebiet, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}